
if exist('apprxorder') ~= 1, apprxorder = 10; end
if exist('colorplotf') ~= 1, colorplotf = 'r'; end
if exist('colorplotapprx') ~= 1, colorplotapprx = 'b'; end
optplotf = {'linewidth',3,'color',colorplotf};
optplotapprx = {'linewidth',3,'color',colorplotapprx};
fontopt = {'fontsize',18,'fontweight','bold'};

n = 1000; x = column(0:n)/n;
k = apprxorder;
Phiksin = zeros(n+1,1); for i = 1:k, Phiksin = [Phiksin sin(2*pi*i*x)]; end
Phiksin = Phiksin(1:n+1,2:k+1);
Phikcos = ones(n+1,1); for i = 1:k, Phikcos = [Phikcos cos(2*pi*i*x)]; end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(1)
ak = column((-1).^(0:k-1)./(1:k));
fk = Phiksin*ak/pi;
f = x-(x>0.5);

plot(x,fk,optplotapprx{:})
hold on
plot(x,f,optplotf{:})
hold off
axy = [0 1.1 -0.6 0.65];
xtick = (0:2)/2;
ytick = [-1 1]/2;
axis(axy)
axis off
drawaxes('xtick',xtick,'ytick',ytick,fontopt{:})

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(2)
bk = abs(ak);
gk = Phiksin*bk/pi;
g = 0.5-x;

plot(x,gk,optplotapprx{:})
hold on
plot([x; 1],[g; 0],optplotf{:})
hold off
axy = [0 1.1 -0.6 0.65];
xtick = (0:2)/2;
ytick = [-1 1]/2;
axis(axy)
axis off
drawaxes('xtick',xtick,'ytick',ytick,fontopt{:})

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Fourier transform of a piecewise constant function.

figure(3)
r = 0.345;
ck = [r; sin(2*pi*(1:k)'*r)./(1:k)'/pi];
sk = (1-cos(2*pi*(1:k)'*r))./(1:k)'/pi;
hk = Phiksin*sk+Phikcos*ck;
h = (x<r);

plot(x,hk,optplotapprx{:})
hold on
plot(x,h,optplotf{:})
hold off
axy = [0 1.1 -0.2 1.2];
xtick = (0:5)/5;
ytick = [1 2]/2;
axis(axy)
axis off
drawaxes('xtick',xtick,'ytick',ytick,fontopt{:})


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
k = 100;
dx = (1/n);
Phiksin = zeros(n+1,1); Phikcos = ones(n+1,1);
ak = [0; column((-1).^(0:k-1)./(1:k))]; bk = abs(ak);
errInf = zeros(1,k);
errL2 = zeros(1,k);
errL1 = zeros(1,k);
for i = 1:k,
   Phiksin = [Phiksin sin(2*pi*i*x)];
   Phikcos = [Phikcos cos(2*pi*i*x)];
   fk = Phiksin*ak(1:i+1)/pi;
   gk = Phiksin*bk(1:i+1)/pi;
   % errInf(i) = max(abs(f-fk));
   errInf(i) = abs(max(gk) - max(g))/max(g);
   errL2(i) = sqrt(sum((g-gk).^2*dx));
   errL1(i) = sum(abs(g-gk)*dx);
end

figure(4)
plot(errL1,optplotapprx{:})
