% Makes Figures 1.1, 1.2, 1.3, 1.4, 10.1

fname0 = '~/Matlab/ThreshLab/BookWavelets/BookImages/grootbegijnhofleuven';
fname1 = '04i';
% fname1 = '06h';
fname2 = '1024grey.jpg';
X = imread([fname0 fname1 fname2],'jpg');
% X = imread('~/Matlab/ThreshLab/Tests/TestImages/house.tif','tif');
X = double(X);
p = 2;
pt = 2;
if exist('ext') ~= 1, ext = 'eps'; end
% ext = 'pdf';
dext = ['-d' ext];
if exist('docompression') ~= 1, docompression = 2; end
if exist('dolinear') ~= 1, 
   dolinear = false; 
end
if dolinear==false,
   disp('NONLINEAR compression; type dolinear=true; for linear compression')
else
   disp('LINEAR compression; type dolinear=false; for nonlinear compression')
end
compressionratio = 10;
rho = 1-1/compressionratio;
if dolinear==true, rho = 1; end

M = 3;
ww = X;
wwthr = ww;
[n m] = size(X);
nj = n; mj = m;
nmj = zeros(2,M+1);
for j=1:M, % resolution levels
   wwj = ww(1:nj,1:mj);
   [wwj n1] = FWT2G1D(1:nj,wwj,'Bspline',pt,p,1);
   [wwj m1] = FWT2G1D(1:mj,wwj','Bspline',pt,p,1);
   wwj = wwj';
   if docompression==1,
      % selects fraction 1-rho of the coefficients in each subband at each
      % scale (subbands are vertical, diagonal and horizontal)
      wwjvert = wwj(n1+1:nj,1:m1); nwjvert = (nj-n1)*m1;
      wwjhor = wwj(1:n1,m1+1:mj); nwjhor = n1*(mj-m1);
      wwjdiag = wwj(n1+1:nj,m1+1:mj); nwjdiag = (nj-n1)*(mj-m1);
      wwjvertsort = sort(abs(reshape(wwjvert,1,nwjvert)));
      thrjvert = wwjvertsort(floor(rho*nwjvert));
      wwjvertthr = HT(wwjvert,thrjvert);
      wwjhorsort = sort(abs(reshape(wwjhor,1,nwjhor)));
      thrjhor = wwjhorsort(floor(rho*nwjhor));
      wwjhorthr = HT(wwjhor,thrjhor);
      wwjdiagsort = sort(abs(reshape(wwjdiag,1,nwjdiag)));
      thrjdiag = wwjdiagsort(floor(rho*nwjdiag));
      wwjdiagthr = HT(wwjdiag,thrjdiag);
      wwjthr = wwj; wwjthr(n1+1:nj,1:m1) = wwjvertthr;
      wwjthr(1:n1,m1+1:mj) = wwjhorthr; wwjthr(n1+1:nj,m1+1:mj) = wwjdiagthr;
      wwthr(1:nj,1:mj) = wwjthr;
   elseif docompression==2,
      % selects fraction 1-rho of the detail coefficients at each scale
      % (all subbands mixed)
      wwjthr = wwj; wwjthr(1:n1,1:m1) = 0;
      wwjsort = sort(abs(reshape(wwjthr,1,nj*mj)));
      thrj = wwjsort(n1*m1+floor(rho*(nj*mj-n1*m1)));
      wwjthr = HT(wwj,thrj); wwjthr(1:n1,1:m1) = wwj(1:n1,1:m1);
      wwthr(1:nj,1:mj) = wwjthr;
   end

   ww(1:nj,1:mj) = wwj;
   nmj(1:2,j) = [nj; mj]; 
   mj = m1;
   nj = n1;
end
nmj(1:2,M+1) = [n1;m1];

% reconstruct compressed image from thresholded coeffcients
Xthr = wwthr;
for j=M:-1:1,
   nj = nmj(1,j); mj = nmj(2,j);
   Xjthr = Xthr(1:nj,1:mj);
   Xjthr = IWT2G1D(1:mj,Xjthr','Bspline',pt,p,1)';
   Xjthr = IWT2G1D(1:nj,Xjthr,'Bspline',pt,p,1);
   Xthr(1:nj,1:mj) = Xjthr;
end

% c=0: Display input squared wavelet coefficients (Fig. 1.2)
% c=1: Display thresholded squared wavelet coefficients
for c=0:1,
   if c==1, wwcopy = ww; ww = wwthr; end
   wwabs = abs(ww);
   wwabs(1:n1,1:m1) = 0;
   R = max(max(wwabs));
   wwabs = 256*((R-wwabs)/R).^3;

   R = max(max(abs(ww(1:n1,1:m1))));
   wwabs(1:n1,1:m1) = ww(1:n1,1:m1)*256/R;
   
   figure(2+c)
   image(imageWT2D(ww,n1,m1))
   colormap grey
   axis equal
   axis off
   hold on
   for j=1:M,
      plot([1 nmj(2,j)],nmj(1,j+1)*[1 1],'k','linewidth',3)
      plot(nmj(2,j+1)*[1 1],[1 nmj(1,j)],'k','linewidth',3)
   end
   hold off
   figpos = get(gcf,'position'); figsize = figpos(3:4);
   papersize = figsize/48; figpaperpos = [0 0 papersize];
   set(gcf,'papersize',papersize,'paperposition',figpaperpos)
   fnameout = ['gb' fname1 '2Dcdf22.' ext];
   if c==1, fnameout = ['gb' fname1 '2Dcdf22thr.' ext]; ww = wwcopy; end
   makefigtransparent
   print(dext,fnameout);
end

% Rectangular wavelet transform
wwrec = X;
wwrec = FWT2G1D(1:n,X,'Bspline',pt,p,M);
wwrec = FWT2G1D(1:m,wwrec','Bspline',pt,p,M)';
image(imageWT2D(wwrec,n1,m1))
colormap grey
axis equal
axis off
hold on
for j=1:M,
   plot([1 m],nmj(1,j+1)*[1 1],'k','linewidth',3)
   plot(nmj(2,j+1)*[1 1],[1 n],'k','linewidth',3)
end
hold off
figpos = get(gcf,'position'); figsize = figpos(3:4);
papersize = figsize/48; figpaperpos = [0 0 papersize];
set(gcf,'papersize',papersize,'paperposition',figpaperpos)
fnameout = ['gb' fname1 '2Dcdf22rec.' ext];
   makefigtransparent
print(dext,fnameout);


figure(1)
% Input image
image(X)
colormap grey
axis equal
axis off
figpos = get(gcf,'position'); figsize = figpos(3:4);
papersize = figsize/48; figpaperpos = [0 0 papersize];
set(gcf,'papersize',papersize,'paperposition',figpaperpos)
fnameout = ['gb' fname1 '1024.' ext];
   makefigtransparent
print(dext,fnameout);

figure(4)
% Output image (after compression)
image(Xthr)
colormap grey
axis equal
axis off
figpos = get(gcf,'position'); figsize = figpos(3:4);
papersize = figsize/48; figpaperpos = [0 0 papersize];
set(gcf,'papersize',papersize,'paperposition',figpaperpos)
fnameout = ['gb' fname1 '1024thr.' ext];
if dolinear==true, fnameout = ['gb' fname1 '1024lin.' ext]; end 
   % all details lost
   makefigtransparent
print(dext,fnameout);

Xtilde = dct(X);
Xtilde(floor((1-rho)*n)+1:n,1:m) = 0;
Xdct = idct(Xtilde);

