
% Makes Figures 2.2, 2.3, 2.4, and 2.6

close all
rand('state',0);
randn('state',0);
a4 = 1.4;
M = 4;
Ne = 5;
% xe = sort(rand(1,Ne));
xe = [-1 0 0.55 0.9 2];
Ne = length(xe);
k = ceil(Ne/2);
ye = zeros(size(xe));
ye(k) = 1;
evenplotoptions = {'rs','markersize',18,'markerfacecolor','k',...
                   'markeredgecolor','k'};
oddplotoptions = {'o','markersize',12,'markerfacecolor','white',...
                   'markeredgecolor','k','linewidth',3};
rmin = 0.35;
axy = [-0.4 1.4 -0.1 1.1];
for j = 1:M,
   No = Ne-1;
   % r = rand(1,No);
   r = randn(1,No)/3+0.5; r = max(r,rmin); r = min(r,1-rmin);
   xo = r.*xe(1:No) + (1-r).*xe(2:Ne);
   yo = r.*ye(1:No) + (1-r).*ye(2:Ne);
   xx = zeros(1,Ne+No); yy = zeros(1,Ne+No);
   xx(1:2:Ne+No) = xe; xx(2:2:Ne+No) = xo;
   yy(1:2:Ne+No) = ye; yy(2:2:Ne+No) = yo;

   xe = xe(xe<1.3); nxe = length(xe); ye = ye(1:nxe); 
   xo = xo(xo<1.3); nxo = length(xo); yo = yo(1:nxo);

   plot(xe,ye,'--','color','k','linewidth',2)
   hold on
   plot(xe,ye,evenplotoptions{:})
   plot(xo,yo,oddplotoptions{:})
   axis(axy)
   axis off
   drawaxes
   fname = ['CDF22subdivisionstep' num2str(j)];
   print('-deps',fname)
   hold off
   % pause
   Ne = Ne+No;
   xe = xx; ye = yy;
end

plotasblocks(xx,yy,'linewidth',3,'color','k')
axis(axy)
axis off
drawaxes
fname = 'CDF22subdivisionstair';
print('-deps',fname)



N = 12;
% x = makegrid(N,1);
x = (xx(1:N)-xx(1))/(xx(N)-xx(1));
Phi = eye(N);
bulletsize = 12;
gridplotoptions = {'o','markersize',bulletsize,'markeredgecolor','k',...
                       'markerfacecolor','k'};
figure(1)
plot(x,zeros(size(x)),gridplotoptions{:});
hold on
color0 = [1 1 1]/3; color1 = [0 0 0];
c = column(mod(1:N,3))/2;
colors = c*color0+(1-c)*color1;
for k = 1:N,
   kk = (max(k-1,1):min(k+1,N));
   colork = colors(k,1:3);
   plot([0 x(kk) 1],[0; Phi(kk,k); 0],'color',colork,'linewidth',4)
   % pause
end
plot(x,zeros(size(x)),gridplotoptions{:});
aa = axis;
aa(4) = a4;
% a3 = aa(3); plot(x(N)*[1 1],[a3 a4],'k','linewidth',3)
aa(2) = 1.1;
hold off
axis(aa);
axis off
set(gcf,'position',[0 0 800 400])
set(gcf, 'PaperPosition', [0 0 12 6]);
drawaxes
print -depsc CDF22phiJ.eps

% The CDF 2,2 wavelets have the interesting property that the refinement after
% the first step always generates points on existing polylines. A plot of the
% basis functions at course level, using polyline interpolation thus generates
% the exact curves at infinite refinement
% We therefore continue to work with N=12 points in x (no further refinement
% needed)

I = eye(N);
Psi = IWT2G1D(x,I,'DD',2,2,3);

figure(2)
plot(x,zeros(size(x)),gridplotoptions{:});
hold on
for k = 7:12,
   colork = colors(k,1:3);
   plot([0 x 1],[0; Psi(1:N,k); 0],'color',colork,'linewidth',4)
end
% plot(x,Psi(1:N,7:12),'k');
aa = axis;
aa(4) = a4;
% a3 = aa(3); plot(x(N)*[1 1],[a3 a4],'k','linewidth',3)
aa(2) = 1.1;
hold off
axis(aa);
axis off
set(gcf,'position',[0 0 800 400])
set(gcf, 'PaperPosition', [0 0 12 6]);
drawaxes
print -depsc CDF22psiJmin1.eps

figure(3)
plot(x,zeros(size(x)),gridplotoptions{:});
hold on
for k = 4:6,
   colork = colors(k,1:3);
   plot([0 x 1],[0; Psi(1:N,k); 0],'color',colork,'linewidth',4)
end
aa = axis;
aa(4) = a4;
% a3 = aa(3); plot(x(N)*[1 1],[a3 a4],'k','linewidth',3)
aa(2) = 1.1;
hold off
axis(aa);
axis off
set(gcf,'position',[0 0 800 400])
set(gcf, 'PaperPosition', [0 0 12 6]);
drawaxes
print -depsc CDF22psiJmin2.eps

figure(4)
plot(x,zeros(size(x)),gridplotoptions{:});
hold on
for k = 3:3,
   colork = colors(k,1:3);
   plot([0 x 1],[0; Psi(1:N,k); 0],'color',colork,'linewidth',4)
end
aa = axis;
aa(4) = a4;
% a3 = aa(3); plot(x(N)*[1 1],[a3 a4],'k','linewidth',3)
aa(2) = 1.1;
hold off
axis(aa);
axis off
set(gcf,'position',[0 0 800 400])
set(gcf, 'PaperPosition', [0 0 12 6]);
drawaxes
print -depsc CDF22psiJmin3.eps

figure(5)
plot(x,zeros(size(x)),gridplotoptions{:});
hold on
for k = 1:2,
   colork = colors(k,1:3);
   plot([0 x 1],[0; Psi(1:N,k); 0],'color',colork,'linewidth',4)
end
% plot(x,Psi(1:N,7:12),'k');
aa = axis;
aa(4) = a4;
% a3 = aa(3); plot(x(N)*[1 1],[a3 a4],'k','linewidth',3)
aa(2) = 1.1;
hold off
axis(aa);
axis off
set(gcf,'position',[0 0 800 400])
set(gcf, 'PaperPosition', [0 0 12 6]);
drawaxes
print -depsc CDF22phiL.eps
