
% Makes Figure 3.5
% see also ThreshLab/ThreshLab2/Irregular/1D/illustrate_updateLSapprxprimmom.m

if exist('makeeps') ~= 1, makeeps = true; end
if exist('figsize') ~= 1, figsize = [840 420]; end
if exist('papersize') ~= 1, papersize = figsize/96; end
if exist('figpaperpos') ~= 1, figpaperpos = [0 0 papersize]; end
makeepscopy = makeeps;
dosvd = true; makeeps = false;
makefigvarpropFWTspline
makeeps = makeepscopy;

figpos = get(gcf,'position'); figpos(3:4) = figsize;
set(gcf,'position',figpos,'papersize',papersize,'paperposition',figpaperpos)

plotspecs = {'linewidth',2,'markerfacecolor','w','markersize',7};
bf = {'fontsize',fontsize,'fontweight','bold'};
bfit = {bf{:},'fontangle','italic'};
nL150 = ceil(3*nL/2);
% mm = {'o','d','^','v','s'};
p4 = plot(sigmaptilde4semiorth(1:nL150),'ks-',plotspecs{:});
hold on
p2 = plot(sigmaptilde2p0(1:nL150),'k^-',plotspecs{:});
p3 = plot(sigmaptilde4p2(1:nL150),'ko-',plotspecs{:});
p1 = plot(sigmaptilde2p2(1:nL150),'kv-',plotspecs{:});
aa = axis;
hold off
% make reasonable choice for range on axes
aa(4) = floor(min(aa(4),max(10,sigmaptilde4p2(1))));
% aa(4) = floor(min(aa(4),max(8,sigmaptilde2p0(1))));
% aa(2) = 2*nL-1;
aa(2) = nL150 +5;
aa(4) = aa(4)+1;
aa(3) = aa(3)-(aa(4)-aa(3))/15;
axis(aa)
% title('SVD projections W*Wtilde',bf{:})
axis off
% drawaxes('ytick',(0:2:aa(4)),'xtick',nL,'xticklabel',{'n_L'},bf{:})
% If you prefer n_L in font italic, then type
drawaxes('ytick',(0:2:aa(4)),'xtick',nL,'xticklabel','',bf{:})
text(nL-0.5,aa(3),'n_L',bfit{:})
% The drawaxes command puts the 
ppp = [p1 p2 p3 p4];
legend(ppp,'triangular hat, 2 primal moments',...
           'triangular hat, no primal moments',...
           'cubic spline, 2 primal moments',...
           'semi-orthogonal cubic spline',bf{:})
if makeeps == true, print -depsc SVDprojFWTspline.eps, end
