% Makes Figure 10.6

if exist('makeeps') ~= 1, makeeps = false; end
darkcolor  = [1 1 1]*0.5;
edgecolor  = [1 1 1]*0.7;
lightcolor = [1 1 1]*0.9;
linecolor  = 'k';
lineopt    = {'color',linecolor,'linewidth',3};
frameopt   = {'color',linecolor,'linewidth',3};
m = 1000;
t = (0:m-1)'/(m-1);
a = 0.5;
b = 0.3;
x = a*cos(4*t-1).^2+b;
c = exp(pi/2)-1;
y = sin(log(1+c*t.^2));
xx = [0; x; 0; 0]; yy = [0; y; 1; 0]; mm = length(xx);
xxx = [-1; x; -1; -1]; yyy = [-1; y; 2; -1];
fill([0 0 1 1],[0 1 1 0],lightcolor)
hold on
fill(xx,yy,darkcolor)
plot(x,y,lineopt{:})
plot([0 0 1 1 0],[0 1 1 0 0],frameopt{:})
hold off
axis equal
axis([0 1 0 1])
axis off
if makeeps == true,
   makefigtransparent
   fname = 'linesingularity2D.eps';
   print('-deps',fname);
end

L = 3;
M = 3;
J = L+M;
for j = L:J-1,
   fill([0 0 1 1],[0 1 1 0],lightcolor)
   hold on
   fill(xx,yy,darkcolor)
   nj = 2^j;
   hj = 1/(nj-1);
   % [xj yj] = meshgrid((0:nj-1)/(nj-1),(0:nj-1)/(nj-1));
   xj = (0:nj-1)/(nj-1); yj = xj;
   fj = false(nj,nj);
   for k=1:nj, for l=1:nj,
      fj(k,l) = pointinside(xj(k),yj(l),1:mm,xxx,yyy);
   end, end
   edgej = false(nj,nj);
   edgej(1:nj-1,1:nj) = (fj(2:nj,1:nj)~=fj(1:nj-1,1:nj));
   edgej(1:nj,1:nj-1) = edgej(1:nj,1:nj-1)|(fj(1:nj,2:nj)~=fj(1:nj,1:nj-1));
   edgej(1:nj-1,1:nj-1) = edgej(1:nj-1,1:nj-1)|...
                          (fj(2:nj,2:nj)~=fj(1:nj-1,1:nj-1));
   [kk ll] = find(edgej);
   for i = 1:length(kk),
      k = kk(i); l = ll(i);
      fill(xj(k)+[0 0 hj hj],yj(l)+[0 hj hj 0],edgecolor)
   end
   plot(x,y,lineopt{:})
   plot([0 0 1 1 0],[0 1 1 0 0],frameopt{:})
   hold off
   axis equal
   axis([0 1 0 1])
   axis off
   if makeeps == true,
      makefigtransparent
      fname = ['linesingularity2Dj' num2str(j) '.eps'];
      print('-deps',fname);
   elseif j<J-1,
      txt = ['press any key to proceed to level ' num2str(j+1)'];
      disp(txt)
      pause
      disp('-------------------------------------')
   else
      disp('no eps files have been created. Set makeeps=true;')
   end

end
