
% Makes Figures 10.2 and 10.3

fontopt = {'fontsize',18,'fontweight','bold'};
if exist('BW') ~= 1, BW = true; end
if exist('makeeps') ~= 1, makeeps = false; end

if BW==true,
   % fullcolors = 0.3+(0:5)'/5*0.5*[1 1 1];
   fullcolors = 0.9-(5:-1:0)'/20*[1 1 1];
else
   % fullcolors = [0 0 1; 0 1 0; 0 1 1; 1 0 0; 1 0 1; 1 1 0];
   fullcolors = [0 0 1; 1 0.8 0.2; 0.4 1 0.3; 1 0 0; 1 0 1; 0 1 1];
end

n = 20;
u1 = [
   0.952782149656615
   0.704062166774998
   0.953877473592231
   0.598158524172189
   0.840743198113070
   0.442818842235133
   0.836819600676340
   0.518703059724916
   0.022209778572601
   0.375885601263150
   0.898595722402065
   0.429001488239939
   0.199570860468184
   0.303094713011787
   0.538299796840526
   0.910235215540284
   0.525292524432423
   0.306830377006756
   0.034469524543484
   0.715335129762360];
u2 = [
   0.768715996224281
   0.059516038023571
   0.627098531081169
   0.265189419023722
   0.312344006694141
   0.422694779016024
   0.408626133070308
   0.892932028832867
   0.573771104628533
   0.567888671171215
   0.394500645463465
   0.691591303114978
   0.569323663878234
   0.343218763408012
   0.594935735186864
   0.273946239977262
   0.048100029521024
   0.838089064493547
   0.102541386545559
   0.728274628286352];
n = length(u1);

[triu Btriu]= inittri(u1,u2);
fill(u1(Btriu),u2(Btriu),[1 1 1]*0.8);
hold on
plotmesh(triu,u1,u2,'k','linewidth',2)
plot(u1,u2,'k.','MarkerSize',40)
hold off
axy = [min(u1) max(u1) min(u2) max(u2)];
axis equal
axis(axy)
axis off
% axy = axis;

if makeeps==true,
   makefigtransparent
   print -depsc nonconvexdelaunaytriu.eps
end

alfa = pi/2;
b = 0.15; % relative width of the data cloud
angle = u1*alfa/2 + alfa/2;
radius = 1+b*u2;
% angle = rand(1,N)*alfa;
x1 = radius.*cos(angle);
x2 = radius.*sin(angle);

fill(x1(Btriu),x2(Btriu),[1 1 1]*0.8);
hold on
plotmesh(triu,x1,x2,'k','linewidth',2)
plot(x1,x2,'k.','MarkerSize',40)
hold off
axis equal
axis off

[trix Btrix]= inittri(x1,x2);
fill(x1(Btrix),x2(Btrix),[1 1 1]*0.8);
hold on
plotmesh(trix,x1,x2,'k','linewidth',2)
plot(x1,x2,'k.','MarkerSize',40)
hold off
axis equal
axis off

fill(u1(Btrix),u2(Btrix),[1 1 1]*0.8);
hold on
plotmesh(trix,u1,u2,'k','linewidth',2)
plot(u1,u2,'k.','MarkerSize',40)
hold off
axis equal
axis(axy)
axis off

if makeeps==true,
   makefigtransparent
   print -depsc nondelaunaytriu.eps
else
   disp('Press any key to continue to Fig 2/3')
   pause
end

% Effect of a linear transform
u = [u1 u2];
A = [1 4;3 1];
x = u*A;
x1 = x(1:n,1); x2 = x(1:n,2);
[trix Btrix]= inittri(x1,x2);
fill(u1(Btrix),u2(Btrix),[1 1 1]*0.8);
hold on
plotmesh(trix,u1,u2,'k','linewidth',2)
% plotmesh(triu,u1,u2,'r','linewidth',2)
plot(u1,u2,'k.','MarkerSize',40)
hold off
axis equal
axis(axy)
axis off

if makeeps==true,
   makefigtransparent
   print -depsc nondelaunaytriuA.eps
else
   disp('Press any key to continue to Fig 3/3')
   pause
end


fulltriu = bndrycstrdelaunay1(u1,u2);
V = cell(n,1);
% M = 0.3; u1ext = [u1;-M;-M;1+M;1+M]; u2ext = [u2;-M;1+M;1+M;-M];
M = 0.5; next = 4; 
u1ext = [-M*ones(next,1);(2*M+1)*(1:next)'/next-M;(M+1)*ones(next,1);...
             (2*M+1)*(next-1:-1:0)'/next-M];
u2ext = frwshift(u1ext,next);
u2ext = [u2;u2ext]; u1ext = [u1; u1ext];
for i = 1:n,
   V{i} = constructvoronoicell(i,u1ext,u2ext);
end
cellcolors = zeros(1,n);
for i = 1:n,
   neighbi = findneighbours(i,fulltriu);
   neighborcolors = cellcolors(neighbi);
   cellcolors(i) = min(setdiff(1:6,neighborcolors));
   cc = fullcolors(cellcolors(i),1:3);
   fill(V{i}(:,1),V{i}(:,2),cc)
   hold on
   % text(u1(i),u2(i),num2str(i),fontopt{:})
end
plotmesh(fulltriu,u1,u2,'k','linewidth',2)
plot(u1,u2,'k.','MarkerSize',40)
hold off
axis equal
axis(axy)
axis off
if makeeps==true,
   makefigtransparent
   print -depsc convexdelaunaytriu.eps
end

