% Makes Figure 9.3

if exist('makeeps') ~= 1, makeeps = false; end
if exist('makepdf') ~= 1, makepdf = false; end
if exist('dualmom') ~= 1, dualmom = 4; end
if exist('primmom') ~= 1, primmom = 2; end
% Current version of RWT_2Gspline.m (ThreshLab, version 4.5.2) has no
% implementation for primmom = [p nu-p] !!!
M = 1;
n = 64;
gridnumber = 1;
randomgrid = false; 

I = eye(n);
x = makegrid(n,gridnumber,randomgrid)';
[Wt, nL] = FWT2G1D(x,I,'Bspline',dualmom,primmom,M);
W = IWT2G1D(x,I,'Bspline',dualmom,primmom,M);

VL = W(1:n,1:nL);
VtL = Wt(1:nL,1:n);
VtsemiorthL = (VL'*VL)\VL';
PL = VL*VtL;
PsemiorthL = VL*VtsemiorthL;

O = zeros(n,n);
Wtnondec = RWT_2Gspline(x,I,dualmom,primmom,M);
VtnondecL = Wtnondec{M+1};
VnondecL = IRT_2Gspline(x,{O,I},dualmom,primmom);
PnondecL = VnondecL*VtnondecL;

% check (see also testRWT20200105.m)
[e, o] = splitevenodd(x);
VLbis = 2*VnondecL(1:n,e);
checkVL = max(max(abs(VL-VLbis)))
VtLbis = VtnondecL(e,1:n);
checkVtL = max(max(abs(VtL-VtLbis)))
PLbis = VLbis*VtLbis;

VcL = 2*VnondecL(1:n,o);
VtcL = VtnondecL(o,1:n);
VtcsemiorthL = (VcL'*VcL)\VcL';
PcL = VcL*VtcL;
PcsemiorthL = VcL*VtcsemiorthL;

PmeanL = (PL+PcL)/2; checkPmeanL = max(max(abs(PmeanL-PnondecL)))

VtnondecsemiorthL = (VnondecL'*VnondecL)\VnondecL';
PnondecsemiorthL = VnondecL*VtnondecsemiorthL;

[U, Ssemiorth, V] = svd(PsemiorthL); sigmaPsemiorthL = diag(Ssemiorth);
[U, Scsemiorth, V] = svd(PcsemiorthL); sigmaPcsemiorthL = diag(Scsemiorth);
[U, S, V] = svd(PL); sigmaPL = diag(S);
[U, Sc, V] = svd(PcL); sigmaPcL = diag(Sc);
[U, Snondec, V] = svd(PnondecL); sigmaPnondecL = diag(Snondec);
[U, Snondecsemiorth, V] = svd(PnondecsemiorthL); 
sigmaPnondecsemiorthL = diag(Snondecsemiorth);

checkPLTPL = max(max(abs((PL'*PL+PcL'*PcL+PcL'*PL+PL'*PcL)/4-PnondecL'*PnondecL)))

fontsize = 14;
plotspecs = {'linewidth',2,'markerfacecolor','w','markersize',7};
bf = {'fontsize',fontsize,'fontweight','bold'};
bfit = {bf{:},'fontangle','italic'};
nL150 = ceil(3*nL/2);
% mm = {'o','d','^','v','s'};
p1 = plot(sigmaPsemiorthL(1:nL150),'ks-',plotspecs{:});
hold on
p2 = plot(sigmaPL(1:nL150),'k^-',plotspecs{:});
p3 = plot(sigmaPcL(1:nL150),'kv-',plotspecs{:});
p4 = plot(sigmaPnondecL(1:nL150),'ko-',plotspecs{:});
hold off

figsize = [840 420]; papersize = figsize/96; figpaperpos = [0 0 papersize];
figpos = get(gcf,'position'); figpos(3:4) = figsize;
set(gcf,'position',figpos,'papersize',papersize,'paperposition',figpaperpos)

aa = axis;
aa(4) = floor(min(aa(4),max(10,sigmaPL(1))));
aa(2) = nL150 +5;
aa(4) = aa(4)+1;
aa(3) = aa(3)-(aa(4)-aa(3))/15;
axis(aa)
% title('SVD projections W*Wtilde',bf{:})
axis off
yticks = bestticks(aa(4));
drawaxes('ytick',yticks,'xtick',nL,'xticklabel',{'n_L'},bf{:})
ppp = [p1 p2 p3 p4];
legend(ppp,'semi-orth. FWT proj.','FWT proj.',...
           'Compl. FWT proj.','RWT "proj."',bf{:})
% text(nL-0.5,aa(3),'n_L',bfit{:})
if makeeps==true,
   makefigtransparent
   print -depsc SVDprojRWTspline.eps
end
if makepdf==true,
   makefigtransparent
   print -dpdf SVDprojRWTspline.pdf
end
if makeeps==false & makepdf==false,
   disp('no file has been printed. Set makepdf=true; or makeeps=true;')
end


normPLfrob = norm(PL,'fro')
normPLfrobis = norm(sigmaPL)
normPcLfrob = norm(PcL,'fro')
normPnondecLfrob = norm(PnondecL,'fro')


