
% Makes Figure 8.1
if exist('makeeps') ~= 1, makeeps = false; end
linecolor  = 'k';
lineopt    = {'color',linecolor,'linewidth',3};
fontopt = {'fontsize',18,'fontweight','bold'};
n = 1000;
x = (0:n)/n;
aa = [3/4 2/3 1/2 1/3 1/4];
a0 = min(aa);
x0 = 0.345;
f0 = 1/2;
figure(1)
plot([0 x0 x0],[f0 f0 0],':',lineopt{:})
hold on
figure(2)
plot([x0 x0],[0 20],':',lineopt{:})
hold on
for a = row(aa)
   v = sign(x-x0).*abs(x-x0).^a/a;
   % tanhv = (exp(v)-exp(-v))./(exp(-v)+exp(v));
   f = f0 + tanh(v)/2;
   fprime = (1-tanh(v).^2)/2.*abs(x-x0).^(a-1);
   % d/dx tanh(x) = [1-tanh(x)^2]
   lineopt{2} = sqrt(a-a0)*[1 1 1];
   figure(1)
   plot(x,f,lineopt{:})
   figure(2)
   plot(x,fprime,lineopt{:})
end
xticks = {'xticks',[0 x0 1],'xticklabels',{'0','x_0','1'}};
yticks = {'yticks',[1/2 1],'yticklabels',{'1/2','1'}};
lineopt{2} = linecolor;
figure(1)
hold off
axis([0 1.1 0 1.1])
axis off
drawaxes(xticks{:},yticks{:},fontopt{:})
figure(2)
hold off
axis([0 1.1 0 5])
axis off
drawaxes(xticks{:},fontopt{:})
fnames = {'sobolevf.eps','sobolevfprime.eps'};
if makeeps == true,
   for fig=1:2,
      figure(fig)
      makefigtransparent
      print('-deps',fnames{fig});
   end
else
   disp('no eps files have been created. Set makeeps=true;')
end

