
function day = date2day(date);

% date2day -- computes number of days between given dates
%  Usage
%    day = date2day(date);
%  Inputs
%    date     vector of dates, format yyyymmdd
%  Outputs
%    day      vector of integers, the first of which is zero
%  Description
%  Note
%  See also
%    help day2date

if length(date) < 2,
   date = [00010101 date];
end
sizedate = size(date);
date = row(date);
day = round(frac(date/100)*100);
month = round(frac(floor(date/100)/100)*100);
year = round(date/10000);
daysinmonth = [31 28 31 30 31 30 31 31 30 31 30 31];
daysinmonth = frwshift(daysinmonth,month(1)-1);
signmonth = double(month<month(1));
day = day - day(1);
leapdays = floor(year/4) - floor(year/100) + floor(year/400);
leapyears = (mod(year,4)==0 & mod(year,100)~=0) | mod(year,400)==0;
leapdays = leapdays - double(leapyears&(month<3));
month = mod(month - month(1),12)+1;
% if date contains a NaN, then month also contains a NaN, which cannot be used
% further on as an index into a vector cumdaysinmonth
month(isnan(month)) = 1;
leapdays = leapdays - leapdays(1);
year = year - year(1) - signmonth;
cumdaysinmonth = [0 cumsum(daysinmonth)];
day = day + 365*year + cumdaysinmonth(month) + leapdays;
day = reshape(day,sizedate);
