
function R = inarow(B);

% ThreshLab/General/inarow: finds numbers of TRUE in a row for a binary vector
%  Usage
%    R = inarow(B);
%  Inputs
%    B : binary vector or matrix
%  Outputs
%    R : integer vector or matrix of size(B)
%  Description
%    for vectors:
%    if B(i) == 0, then R(i) = 0
%    if B(i) == 1, then R(i) = R(i-1)+1
%    for matrices, apply vector operation to columns
%  Note
%  See also

B = (abs(B)>0); doBt = false;
[n m] = size(B); if n==1, B=B'; n=m; m=1; doBt = true; end
R = zeros(size(B));
R(1,1:m) = B(1,1:m);
for i=2:n, R(i,1:m) = B(i,1:m).*(R(i-1,1:m)+B(i,1:m)); end
if doBt, R=R'; end

% Copyright (c) Maarten Jansen
% 
% This software is part of ThreshLab and is copyrighted material. 
