function f = clawpdf(x);

% ThreshLab/Noise/clawpdf -- claw probablity density function 
%    Usage
%      f = clawpdf(x);
%    Inputs
%      x    vector or scalar
%    Outputs
%      f    vector of size(x) and/or size(s)
%    Description
%      f = 
%    Note

f = gauss(x)/2+gauss(10*(x+1))+gauss(10*(x+1/2))+gauss(10*x)+...
               gauss(10*(x-1))+gauss(10*(x-1/2));
% equivalently:
f = gauss(x,1)/2+gauss(x+1,0.1)/10+gauss(x+1/2,0.1)/10+gauss(x,0.1)/10+...
               gauss(x-1,0.1)/10+gauss(x-1/2,0.1)/10;

% Copyright (c) Maarten Jansen
% 
% This software is part of ThreshLab and is copyrighted material. 

