
function yy = polyline(xx,x,y);

% polyline - ThreshLab2/Polylines --- evaluate polyline defined by knots
%   Usage
%     yy = polyline(xx,x,y);
%   Inputs
%     x     x-coordinates of knots
%     y     y-coordinates of knots
%     length(x) = length(y)
%     xx    x-coordinates of evaluation points
%   Outputs
%     yy    y-coordinates of evaluation points
%   Description
%     defines function values yy in xx of polyline interpolating in (x,y)
%     y can be a matrix, the evaluation then takes place in a row-by-row or a
%     column-by-column fashion.
%   See also
%     help Bsplinebasis
%     help polylineproduct
%     help staircase

% [r c] = size(y);
% if c == size(x,2), y = y'; end
x = column(x);
[r c] = size(y);
if r ~= length(x), y = y'; end
[r c] = size(y);
if r ~= length(x),
   error('abscis-ordinate mismatch in polyline knots (x,y)')
end

Phi = Bsplinebasis(xx,x,2);
yy = Phi*y;
if size(xx,1)==1, yy=yy'; end
