
function A = areapoints(points,x,y);

% areapoints - ThreshLab2/Triangulations --- finds area of polygon
%   Usage
%      A = areapoints(points,x,y);
%   Inputs
%     points   vector of size n with indices into vectors x and y
%     x        x-coordinates of 2d-scattered data
%     y        y-coordinates of 2d-scattered data
%   Outputs
%     A        scalar, area of polygon (x(points),y(points))
%   Description
%     computes area of polygon defined by boundary in (x(points),y(points))
%     (uses boundary constraint triangulation)
%   Note
%   See also
%      help areatri
%      help bndrycstrbndrydelaunay1

if nargin==2, y = x; x = points; points = (1:length(x)); end
if length(points) < 3,
   A = 0;
else
   tri = bndrycstrbndrydelaunay1(points,x,y);
   A = sum(abs(areatri(tri,x,y)));
end
