
function A = areatri(tri,x,y);

% areatri - ThreshLab2/Triangulations --- finds area of triangle
%   Usage
%      A = areatri(tri,x,y);
%   Inputs
%     tri      n-by-3 matrix with indices into vectors x and y
%     x        x-coordinates of 2d-scattered data
%     y        y-coordinates of 2d-scattered data
%   Outputs
%     A        vector of length n
%   Description
%     compute for every triangle in tri its area
%     A = (x1.*y2-y1.*x2+x2.*y3-y2.*x3+x3.*y1-y3.*x1)/2;
%   Note
%   See also
%      help areapoints

if size(tri,2) < 3, tri = tri'; end
if size(tri,2) < 3, 
   error('triangle requires 3 points; input argument tri has incorrect number')
end

x1 = x(tri(:,1));
x2 = x(tri(:,2));
x3 = x(tri(:,3));
y1 = y(tri(:,1));
y2 = y(tri(:,2));
y3 = y(tri(:,3));
% A = (x3-x1).*(y3-y1) - (x2-x1).*(y2-y1) - (x3-x2).*(y3-y2);
% A = A/2 - (x3-x2).*(y2-y1);
A = (x1.*y2-y1.*x2+x2.*y3-y2.*x3+x3.*y1-y3.*x1)/2;
