
function B = pointinedge(p0,e,x,y);

% pointinedge - ThreshLab2/Triangulations --- checks if a point lies on the
%               edge defined by two other points 
%   Usage
%     B = pointinedge(p0,e,x,y);
%   Inputs
%     p0       integer; index into data cloud (x,y), defining a vertex
%     e        pair of integers; indices into data cloud (x,y), defining an
%                                edge
%     x        x-coordinates of 2d-scattered data
%     y        y-coordinates of 2d-scattered data
%   Outputs
%      B       Boolean variable 
%   Description
%      checks if (x(p0),y(p0)) is on the egde 
%      (x(e(1)),y(e(1))) - (x(e(2)),y(e(2)))
%   See also
%      help pointonline

x0 = x(p0);
y0 = y(p0);
x1 = x(e(1));
y1 = y(e(1));
x2 = x(e(2));
y2 = y(e(2));

B = pointonline(x0,y0,x1,y1,x2,y2);
