
function segment = pointonboundary(p0,points,x,y);

% pointonboundary - ThreshLab2/Triangulations --- checks if a point lies on the
%               boundary of a polygon
%   Usage
%      segment = pointonboundary(p0,points,x,y);
%   Inputs
%     p0       integer; index into (x,y) defining a vertex
%     points   ordered vector of at least three integers, indices into (x,y)
%     x        x-coordinates of 2d-scattered data
%     y        y-coordinates of 2d-scattered data
%   Outputs
%     segment  integer; 0 if p0 not on polygon defined by points
%                       otherwise index into points 
%   See also
%      help pointinside
%      help pointinedge
%      help pointonline
%      help pointonpolyline

segment = 0;
n = length(points);
pp = [points points(1)];
for p=1:n,
   e = [pp(p) pp(p+1)];
   if pointinedge(p0,e,x,y),
      segment = p;
   end
end
