% THRESHLAB Threshold
% -----------------
% 
% Routines for noise reduction by wavelet coefficient thresholding
% 
% .m - files
% ----------
% Contents.m       : this file
% HT.m             : Hard threshold operation
% ST.m             : Soft threshold operation
% oracle.m         : optimal coefficient selection
% samplePEonS.m    : sample PE for LS or shrinkage est. on selection S
% CponSmodelsize.m : Cp for LS or shrinkage estimates on selection S
% GCVonSmodelsize.m: GCV for LS or shrinkage estimates on selection S
% 
% subdirectories
% --------------
% GCV/  : Threshold selection by SURE (Stein's Unbiased Risk Estimation)
%                             and GCV (Generalized Cross Validation)
% MSE/  : Exact mean square error plots/minimization
% Risk/ : Risk = expected MSE (theoretical issues)
% FDR/  : False Discovery Rate thresholds (Benjamini & Hochberg)
% EBayesThresh/ : Empirical Bayesian Thresholds (Johnstone & Silverman)
% IterativeThresholding/ : methods for iterative thresholding and LASSO


% Copyright (c) Maarten Jansen
%
% This software is part of ThreshLab and is copyrighted material. 
