
function G = edges2graphmatrix(E,makesym);

% edges2graphmatrix - ThreshLab/Trees
%  Usage
%    G = edges2graphmatrix(E);
%    G = edges2graphmatrix(E,makesym);
%  Inputs
%    E        two column matrix of integers
%    makesym  logical/boolean, default true (make symmetric output)
%  Outputs
%    G        square binary matrix
%  Note
%    diagonal elements G(i,i) are zero. (unless E contains [i i])
%    Set G = min(1,G+eye(size(G,1))); for ones on the diagonal
%  See also
%     help graphedges
%    

if nargin<2, makesym = true; end
two = size(E,2);
nE = size(E,1); if nE==2 & two>2, E = E'; nE = two; two = 2; end
if two~=2, error('incorrect input format'); end
i = E(1:nE,1); j = E(1:nE,2);
vertices = unique([i;j]);
n = max(vertices);
ij = n*(j-1)+i;
G = sparse(zeros(n,n));
G(ij) = 1;
if makesym, G = min(1,G+G'); end
