
% This routine generates the figures of the paper
%       Information criteria for structured parameter
%       selection in high dimensional tree and graph models
% Check the code to find out which routines are called to actually perform the
% simulations

% 

disp('First generate the plots on best subtree selection')
% Figures 1 to 5
nsimul = 1;
writeoutput = false;
forceplots = true;
plotsimulationsummary = false;
BW = true;
kmax = 50;
simulationstudychangepointpoissonAUHT

% Figure 6
clear
ans = false;
disp('The full simulation study takes several hours.')
input('Press 1 <enter> to launch the full simulation. Press <enter> to skip: ')
dofullsimul = ans;
if dofullsimul==true,
   simulationstudychangepointpoissonAUHT
end

% Figures 7 and 8
disp('------------------------------------------------------------------')
disp('Second generate the plots on graphical model selection')
disp('Press any key to close all existing figures')
pause
close all
figsize = [480 480]; papersize = figsize/96; figpaperpos = [0 0 papersize];
framex = [0 1 1 0 0]; framey = [0 0 1 1 0];
edgecolor = {'color',[1 1 1]*0.3};
nodeopt = {'ko','markersize',2,'markerfacecolor','k'};
fontsize = 14;
% defines fontop in simulatenodewise

useIC = {'Cp','Cp'}; addmirror = true;
randn('state',1); rand('state',1);
simulatenodewise
close all

figure(1)
plotedges(E,x,y,edgecolor{:})
hold on
plot(x,y,nodeopt{:})
plot(framex,framey,'k','linewidth',3)
hold off
axis equal
axis tight
axis off
title('True graph',fontopt{:})

figure(2)
plotedges(Ehat,x,y,edgecolor{:})
hold on
plot(x,y,nodeopt{:})
plot(framex,framey,'k','linewidth',3)
figpos = get(gcf,'position'); figpos(3:4) = figsize;
set(gcf,'position',figpos,'papersize',papersize,'paperposition',figpaperpos)
hold off
axis equal
axis tight
axis off
title('estimated graph',fontopt{:})

G = edges2graphmatrix(E);
Ghatfalsepos = max(0,Ghat-G);
Ghatfalseneg = max(0,G-Ghat);
Ehatfalsepos = graphedges(Ghatfalsepos);
Ehatfalseneg = graphedges(Ghatfalseneg);

figure(3)
plotedges(Ehatfalsepos,x,y,edgecolor{:})
hold on
plotedges(Ehatfalseneg,x,y,'k')
plot(x,y,nodeopt{:})
plot(framex,framey,'k','linewidth',3)
hold off
axis equal
axis tight
axis off
title('False positives and false negatives',fontopt{:})

useIC = {'Cp','none'};
simulatenodewise
EhatCp = Ehat;

figure(5)
plotedges(Ehat,x,y,edgecolor{:})
hold on
plot(x,y,nodeopt{:})
plot(framex,framey,'k','linewidth',3)
figpos = get(gcf,'position'); figpos(3:4) = figsize;
set(gcf,'position',figpos,'papersize',papersize,'paperposition',figpaperpos)
hold off
axis equal
axis tight
axis off
title('estimated graph',fontopt{:})


nnmax = 4;
simulatenodewise
EhatCpnnmax4 = Ehat;

figure(4)
plotedges(Ehat,x,y,edgecolor{:})
hold on
plot(x,y,nodeopt{:})
plot(framex,framey,'k','linewidth',3)
figpos = get(gcf,'position'); figpos(3:4) = figsize;
set(gcf,'position',figpos,'papersize',papersize,'paperposition',figpaperpos)
hold off
axis equal
axis tight
axis off
title('estimated graph',fontopt{:})
